/////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                 //
//              ***  **** ****  **  ***  *   *     ***** **** ***  ***   **  *** *  *              //
//              *  * *    *    *  * *  * ** **       *   *    *  * *  * *  *  *  ** *              //
//              *  * ***  ***  *  * ***  * * *       *   ***  ***  ***  ****  *  ** *              //
//              *  * *    *    *  * * *  *   *       *   *    * *  * *  *  *  *  * **              //
//              ***  **** *     **  *  * *   *       *   **** *  * *  * *  * *** * **              //
//                                                                           by Markus Wiedenmeyer //
/////////////////////////////////////////////////////////////////////////////////////////////////////    

#define PRAGMA_PATH "Terrain";
#define PRAGMA_PATH "Bitmaps";

#include <acknex.h>
#include <default.c>
#include "terrain_edit.c"

VECTOR temp_vec;

void ENDE()
{
	sys_exit("ENDE");	
}

action TERRAIN()
{
	my.skill99 = 100;                                                                               // Set this skill to 100 to use this terrain in "DEFORM TERRAIN"
}

action MY_PLAYER()
{
	var Distanz_x = 0;
	var Distanz_y = 0;
	var Distanz_z = 0;
	var My_pan = 0;
	var My_tilt = 0;
	var Reibung = 0;                                                                                // Verzgerung auf- und abwrts
	VECTOR Kraft;                                                                                   // Verzgerung Laufen, Drehen
	VECTOR Distanz;                                                                                 // Laufen, Drehen des Spielers
	
	wait(1);
	
	player = my;
	c_updatehull(me,1);
	camera.genius = my;
	
	while(my)
	{
		My_pan = -5 * mouse_force.x  * time_step + maxv(1 - time_step * 0.7,0) * My_pan;
		c_rotate(my,vector(My_pan,0,0),IGNORE_PASSABLE | IGNORE_FLAG2 | ACTIVATE_TRIGGER | GLIDE);
		my.pan = ang (my.pan);
		
		My_tilt = 5 * mouse_force.y  * time_step + maxv(1 - time_step * 0.7,0) * My_tilt;
		camera.tilt += My_tilt;
		camera.tilt = clamp (camera.tilt,-75,75);
		
		if (My_pan >  0 && !mouse_force.x)  My_pan  -= 0.001;
		if (My_pan <  0 && !mouse_force.x)  My_pan  += 0.001;
		if (My_tilt > 0 && !mouse_force.y)  My_tilt -= 0.001;
		if (My_tilt < 0 && !mouse_force.y)  My_tilt += 0.001;
		
		vec_set(temp_vec,my.x);                                                                      // kopiert my.x in temp
		temp_vec.z -= 4000;                                                                          // setzt my.z auf - 4000 (ergiebt Trace Strahl nach unten)
		result = c_trace(my.x,temp_vec,IGNORE_ME | IGNORE_FLAG2 | IGNORE_PASSABLE | USE_BOX);
		if (result > 5)                                                                              // in der Luft?
		{
			Kraft.x = 0;                                                                              // kann nicht mehr gehen
			Kraft.y = 0;
			Kraft.z = -5;                                                                             // Schwerkraft
			Reibung = 0.1;
		} else {                                                                                     // auf oder nahe dem Boden
			Kraft.x = 25 * key_force.y;                                                               // berechne Kraft des Laufens vorwrts / rckwrts
			Kraft.y = -(25 * key_force.x);                                                            // seitwrts
			Kraft.z = 0;                                                                              // Schwerkraft
			Reibung = 0.6;
		}
		Distanz_x = time_step * Kraft.x + maxv(1 - time_step * Reibung,0) * Distanz_x;               // Laufgeschwindigkeit
		Distanz_y = time_step * Kraft.y + maxv(1 - time_step * Reibung,0) * Distanz_y;               // Seitwrtsbewegung
		Distanz_z = time_step * Kraft.z + maxv(1 - time_step * Reibung,0) * Distanz_z;               // Fallgeschwindigkeit
		Distanz.x = time_step * Distanz_x;                                                           // Spieler luft
		Distanz.y = time_step * Distanz_y;
		Distanz.z = 3;                                                                               // zu z dazuzhlen, GLIDE wird bei unebenem Gelnde bei Stillstand "ausgetrikst"
		c_move (my,Distanz,nullvector,IGNORE_PASSABLE | IGNORE_FLAG2 | ACTIVATE_TRIGGER | IGNORE_CONTENT | GLIDE);
		Distanz.x = 0;
		Distanz.y = 0;
		Distanz.z = time_step * Distanz_z - 3;                                                       // subtrahiere Entfernung zum Boden (!zu z abzhlen)
		c_move (my,Distanz,nullvector,IGNORE_PASSABLE | IGNORE_FLAG2 | ACTIVATE_TRIGGER | IGNORE_CONTENT);
		
		camera.x = player.x;
		camera.y = player.y;
		camera.z = player.z;
		camera.pan = player.pan;
		
		draw_text("Press F1 to start DEFORM TERRAIN",0,0,vector(255,255,255));
		
		wait(1);
	}
}

void main()
{
	video_aspect = 4/3;                                                                             // Don`t start Widescreen - Format
	video_mode = 9;                                                                                 // 12 = 1920 * 1080 Pixels
	video_screen = 2;
	
	max_particles = 100000;                                                                         // needet for "DEFORM TERRAIN"
	
	terrain_lod = 0;
	terrain_chunk = 0;
//	terrain_lod = 4;                                                                                // If you set terrain_lod or terrain_chunk, the level will be reload without this...
//	terrain_chunk = 8;

	on_f1  = DT_EDIT_TERRAIN;
	on_esc = ENDE;

	level_load ("Level_1.wmb");
}
